addHook("JumpSpinSpecial", function(player)
    if (player.mo.skin == "doodle")
         if not (player.pflags & PF_THOKKED)
            P_SetObjectMomZ(player.mo, 17*FRACUNIT)
            S_StartSound(player.mo, sfx_thok)
            P_SpawnThokMobj(player)
            player.pflags = $1|PF_THOKKED
         end
     end
end)
    if (player.mo.state == S_PLAY_JUMP)
    and (player.mo.skin == "doodle")
        and (player.powers[pw_super])
        and not (CBW_Battle)
        and not (player.mo.state == S_PLAY_PAIN)
        and not (player.mo.state == S_PLAY_DEAD)
        and not (player.mo.state == S_PLAY_DRWN)
        player.charging = true
        player.mo.state = S_PLAY_SPINDASH
        S_StartSound(player.mo, sfx_spndsh)
    end   
end)

addHook("PlayerThink", function(player)
    if player.pflags & PF_JUMPED
    and (player.mo.state == S_PLAY_SPINDASH)
    and not (player.cmd.buttons & BT_SPIN)
    and not (player.powers[pw_super])
        player.charging = false
        player.mo.state = S_PLAY_ROLL
        P_SetObjectMomZ(player.mo, 14*FRACUNIT)
        S_StartSound(player.mo, sfx_zoom)
    end
    if player.pflags & PF_JUMPED
    and (player.mo.skin == "doodle")
    and (player.mo.state == S_PLAY_SPINDASH)
    and not (player.cmd.buttons & BT_SPIN)
    and (player.powers[pw_super])
        player.charging = false
        player.mo.state = S_PLAY_ROLL
        P_SetObjectMomZ(player.mo, 17*FRACUNIT)
        S_StartSound(player.mo, sfx_zoom)
    end
end)
